<template>
  <section>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Agregar Ranking</span>
        </div>
        <div class="navbar-end">
          <div class="navbar-item">
            <div class="field">
              <b-switch type="is-twitter">Salir al guardar</b-switch>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
        <form @submit.prevent="validate">
          <div class="columns is-multiline">
             <div class="column is-6">
              <b-field
                label="Tipo de Ranking*"
                :type="{ 'is-danger': errors.has('rankingType') }"
                :message="errors.first('rankingType')"
              >
                 <multiselect 
                 v-model="optionSelected" 
                 :options="options" 
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectRankingType" 
                 placeholder="Seleccionar Tipo de ranking" label="label" track-by="label" option-value="value" />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Ranking*"
                :type="{ 'is-danger': errors.has('playerRanking') }"
                :message="errors.first('playerRanking')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.playerRanking"
                  name="playerRanking"
                  data-vv-as="playerRanking"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Jugador*"
                :type="{ 'is-danger': errors.has('player') }"
                :message="errors.first('player')"
              >
                 <multiselect 
                 v-model="search" 
                 :options="players" 
                 :multiple="false" 
                 select-label=""
                 :close-on-select="true" 
                 :searchable="true"
                 :clear-on-select="false"
                  :preserve-search="true"
                  @select="onSelectPlayer" 
                  label="fullName"
                 placeholder="Seleccionar Jugador"   track-by="id" >
                 <template v-slot:option="{option}">
                <div class="custom-option">
                  <span class="option-label"> <span class="Key_Player">Nombre: </span> {{ option.fullName }}</span>
                  <br>
                  <span class="option-description"><span class="Key_Player">Edad: </span> {{ option.age }}</span>
                   </div>
                     </template>
                 </multiselect>
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Jugador 2*"
                :type="{ 'is-danger': errors.has('player2') }"
                :message="errors.first('player2')"
              >
                 <multiselect 
                 v-model="player2" 
                 :options="players" 
                 :disabled="enableSecondPlayer"
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectPlayer2" 
                 placeholder="Seleccionar Jugador" label="fullName" track-by="id" >
                  <template v-slot:option="{option}">
                <div class="custom-option">
                  <span class="option-label"> <span class="Key_Player">Nombre: </span> {{ option.fullName }}</span>
                  <br>
                  <span class="option-description"><span class="Key_Player">Edad: </span> {{ option.age }}</span>
                   </div>
                     </template>
                 </multiselect>
              </b-field>
            </div>
             <div class="column is-6">
              <b-field
                label="Asociación*"
                :type="{ 'is-danger': errors.has('association') }"
                :message="errors.first('association')"
              >
                 <multiselect 
                 v-model="city" 
                 :options="associations" 
                 select-label=""
                  :preserve-search="true"
                  @select="onSelectAssociation" 
                 placeholder="Seleccionar Asociación" label="city" track-by="fullName" />
              </b-field>
            </div>
            <div class="column is-6">
              <b-field
                label="Puntos*"
                :type="{ 'is-danger': errors.has('point') }"
                :message="errors.first('point')"
              >
                <b-input
                  size="is-medium"
                  v-model="model.point"
                  name="point"
                  data-vv-as="point"
                  v-validate="'required'"
                  placeholder="Requerido"
                />
              </b-field>
            </div>
          </div>
          <nav class="level">
            <!-- Left side -->
            <div class="level-left">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-light"
                  @click="clean"
                  icon-right="eraser"
                  >Limpiar</b-button
                >
              </p>
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-danger"
                  @click="cancel"
                  icon-right="cancel"
                  >Cancelar</b-button
                >
              </p>
            </div>
            <!-- Right side -->
            <div class="level-right">
              <p class="level-item">
                <b-button
                  size="is-medium"
                  type="is-primary"
                  native-type="submit"
                  icon-right="content-save"
                  >Guardar</b-button
                >
              </p>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </section>
</template>
<script lang="ts">
import { Component, Vue, Watch } from "vue-property-decorator";
import BaseVue from "../../core/BaseVue";
import RankingModel from '../../models/ranking.model';
import RankingService from '../../services/rankingService';
  import multiselect from 'vue-multiselect'
import Player from "@/models/player/player.model";
import PlayerService from "@/services/player.service";
import { RankingType } from "@/enums/rankingType";
import AssociationModel from "@/models/association.model";
import AssociationService from "@/services/associationService";
@Component({components:{
  multiselect
}})
export default class RankingAdd extends BaseVue {
  rankingService: RankingService = new RankingService();
  playerService:PlayerService = new PlayerService();
  associationService:AssociationService = new AssociationService();

  model: RankingModel;
  enableSecondPlayer:boolean = true;
  associations:Array<AssociationModel> =[];
  optionSelected:string = "";
  search:string = "";
  city:string = "";
  player2:string = "";

  players:Array<Player> =[];
    options:Array<any> = [
        { value: 1, label: 'Masculino Individual' },
        { value: 2, label: 'Femenina Individual' },
        { value: 3, label: 'Doble Masculino' },
        { value: 4, label: 'Doble Femeninas' },
        { value: 5, label: 'Doble Mixto' }
      ]
  constructor() {
    super();
    this.model = new RankingModel();
  }

  created(){
    this.getAssociation();
  }

    get filteredOptions(): Player[] {
   
      const searchLower = this.search.toLowerCase();
      return this.players.filter(option => option.fullName!.toLowerCase().includes(searchLower));
    }





onSelectPlayer(player:Player){
    this.model.playerId =player.id;
    console.log(this.model);
}
onSelectPlayer2(player:Player){
    this.model.player2Id =player.id;
    console.log(this.model);
}
onSelectAssociation(item:AssociationModel){
  this.model.associationId =  item.id;

}

onSelectRankingType(item:any){

  switch (item.value) {
    case RankingType.DOUBLEFAMLE:
          this.getWPlayers();
      break;
       case RankingType.FEMALESINGLE:
          this.getWPlayers();
      break;
       case RankingType.DOUBLEMALE:
          this.getMPlayers();
      break;
       case RankingType.MALESINGLE:
          this.getMPlayers();
      break;
        case RankingType.DOUBLEMIX:
          this.getPlayers();
      break;
  
    default:
      break;
  }
  this.model.rankingType = Number(item.value);
    if(RankingType.DOUBLEFAMLE === item.value ||
     RankingType.DOUBLEMALE === item.value || 
     RankingType.DOUBLEMIX === item.value){
      this.enableSecondPlayer = false;
     }else{
      this.enableSecondPlayer = true;
     }

     

}
  public cancel() {
    this.$router.push(`${this.$router.currentRoute.path.split("/agregar")[0]}`);
  }

   getPlayers(){
     this.playerService.getPlayer().then((resp:any) =>{
         this.players = resp.data;
     });
   }

   getMPlayers(){
     this.playerService.getMan().then((resp:any) =>{
         this.players = resp.data;
     });
   }
    getWPlayers(){
     this.playerService.getWoman().then((resp:any) =>{
         this.players = resp.data;
     });
   }
     getAssociation(){
     this.associationService.getAssociation().then(resp =>{
         this.associations = resp.data;
     })
  }

  public async validate() {
    debugger
    try {
      var result = await this.$validator.validateAll();
      if (result) {
            this.model.playerId = Number(this.model.playerId);
            this.model.player2Id = this.model.player2Id !== null ? Number(this.model.player2Id) : null;
            this.model.point = Number(this.model.point);
            this.model.playerRanking = Number(this.model.playerRanking);
        await this.rankingService.saveRanking(this.model).then((resp) => {
          this.operationSuccess();
        });
        this.$router.push(
          `${this.$router.currentRoute.path.split("/agregar")[0]}`
        );
        return;
      }
      throw this.$validator.errors.items.map((e) => e.msg);
    } catch (errors) {
      this.operationFailedErrors(errors as Array<string>);
    }
  }

  public clean() {
    this.model = new RankingModel();
  }
}
</script>
<style scoped>
.Key_Player{
  font-weight: 900;
}
</style>
